/* SRE-http add-on, 11/97.
  This will allow clients to issue commands to the server machine.
  It's sort of a "batch telnet".
  Since great mischief can be accomplished if naughty clients
  get access to this add-on, we RECOMMEND modifying the "needed_privs"
  variable below.  By default, it is set to "SUPERUSER".  You ought
  to add a few more, say NEEDED_PRIVS="SUPERUSER COMMAND".
  Note that these are treated as "MUST_HAVE" privileges, the client MUST
  HAVE all of them (Not just one of them).

  Note: as with the DETACH command, you should only use this with commands
       that do not require further user input (i.e.; del d:\foo\bar will
        ask for a Yes/No response, which will be echoed back to the client */


/******* USER - changeable parmeters  ***********/

/* Space delimited list of privileges the client MUST have in order to use this
procedure */
needed_privs="SUPERUSER "

/***********  END of user changable section ******************/


parse arg  ddir, tempfile, reqstrg,list,verb ,uri,user, ,
          basedir ,workdir,privset,enmadd,transaction,verbose, ,
         servername,host_nickname,homedir


/* chekc for needed_privssuperuser */
do mm=1 to words(needed_privs)
  apriv=strip(upper(word(needed_privs,mm)))
  if wordpos(apriv,upper(privset))=0 then do
    'header add WWW-Authenticate: Basic Realm=<!DoCommand>'  /* challenge */
     foo=sref_response('unauth', "You do not have !DoCommand rights ",tempfile,servername)
     return foo
  end  /* Do */
end

 crlf='0d0a'x

 'SEND TYPE text/html as INDXSRCH '
  aa=' <!doctype html public "-//IETF//DTD HTML 2.0//EN">'
  aa=aa||crlf||'<html><head><title>SRE-http: Executing OS/2 Command on ' servername " </title></head><body>"
  aa=aa||crlf||'<h2>Executing OS/2 commands on ' servername ' </h2> <hr>'
  'VAR NAME AA '


acommand=''

do until list=""
   acommand=""
   parse var list a1 '&' list
   parse var a1 avar '=' aval
   avar=upper(strip(avar)); aval=strip(aval)

   aval=translate(aval,' ','+') ; aval=packur(aval)

  itype=0
  if avar='COMMAND'  then do
      acommand=aval
   end
   if avar="CODE"   then do
        acommand=strip(aval) ; itype=1
   end  /* Do */
   if pos('=',a1)=0 then acommand=strip(packur(translate(avar,' ','+')))

   if acommand<>"" then  do
     astat=do_it(acommand,itype)
     if astat=1 then leave
     iterate
   end  /* Do */

end /* do */

if astat=0 then do
  aaa='</pre> </body></html>'; 'var name aaa '
  'SEND COMPLETE '
   return '200 '||extract('bytessent')||'  _Command execution completed'
end

return '203 '||extract('bytessent')||'  _Command execution did not complete'


/* \====================================*/

/***Do a OS/2 command , using rxqueue *********/
do_it:procedure expose tempfile enmadd host_nickname  transaction crlf verbose
   parse arg acomm,itype


mytid=dostid()
port=extract('serverport')
myqueue="SREF_"||port||'_t'||mytid

tt=strip(right(transaction,3))
cmdfile=dostempname(temp_dir||'\f'||tt||'????.cmd')


astrg=make_cmdstrg(acomm,myqueue,itype)  /* make the cmdfile */
if itype=0 then
  aa=' <em>Executing command: </em> <b> ' cvt_adesc(acomm) ' </b> <br><pre>'
else
  aa=' <em>Executing REXX program</em>: <pre> ' cvt_adesc(acomm) ' </pre><hr><pre>'

'var name aa'
foo=rxqueue('s',myqueue); 
anerr=rexxthread("S",astrg)
do forever  /* wait for a ctl-z */
   do while queued()>0
       parse pull adesc
       if left(strip(adesc),1)='1a'x then do
            if strip(substr(adesc,3)) <> transaction then do
               if verbose>1 then say " Residual results detected and ignored: " substr(adesc,2)
               iterate
            end
            return    0      /* end */
        end
       adesc=cvt_adesc(adesc)||crlf
       'VAR NAME ADESC'
       if rc<0 then do
          foo=rxqueue('d',myqueue)
          foo=rxqueue('c',myqueue)
          if verbose>1 then say ' Disconnected: Recreate queue: 'foo
          return 1
       end  /* Do  rc<0 */
   end /* do queued */
   call syssleep 1
end /* do */
return 0




/**************/
/* make a command file to execute an os/2 command */
make_cmdstrg:procedure expose cmdfile transaction
parse arg todo,theq,itype ; theq=strip(theq)
crlf='0d0a'x
if itype=1 then do 
  todo='signal on syntax name taz ; signal on error name taz ; '||crlf||todo||crlf
  todo=todo||'signal off syntax ; signal off error ; signal boop  '||crlf
  todo=todo||'taz: yow=sigl-5; queue "Error In Code (rc, line, condition): "rc","yow"," condition() ; signal off syntax ; signal off error; '
end  /* Do */
todo=strip(todo)
al.1='/* */'
al.2="foo=rxqueue('s','session'); "
al.3='do queued(); pull .; end   '
al.4="foo=rxqueue('s',"||theq||")"
if itype=0 then
   al.5="address cmd '"|| todo ||" 2>&1 < nul | rxqueue "||theq||" '"
else
   al.5=todo
al.6="boop: aa='1a'x||' '||"||strip(transaction)||";queue aa "
al.7=' exit 0'
do mm=1 to 7
  oof=oof||al.mm||'0d0a'x
end
return oof


cvt_adesc:procedure
parse arg adesc
       adesc=sref_replacestrg(adesc,'&','&amp;','ALL')
       adesc=sref_replacestrg(adesc,'<','&lt;','ALL')
       adesc=sref_replacestrg(adesc,'>','&gt;','ALL')
       adesc=sref_replacestrg(adesc,'"','&quot;','ALL')
return adesc

